%global version_major 7
%global version_minor 0
%global version_micro 5
%global version_release GA-redhat-1
%global as_major 7
%global as_minor 0
%global as_rev 5
%global jbossas_version %{as_major}.%{as_minor}.%{as_rev}
%global prodversion 7.0.5

#For CP building, AS rpm may not update
%global as_rpm_version 7.0.5

%global namedreltag .GA-redhat-1
%global fullreltag .GA_redhat_1
%global namedversion %{version}%{?namedreltag}

%define base_name jbossas
# jbhomedir is /usr/share/jbossas  (files must be immutable)
%define jbhomedir %{_datadir}/%{base_name}
# jbossdir is /var/lib/jbossas  (any mutable file like logs must go here)
%define jbossdir %{_localstatedir}/lib/%{base_name}
# jbosslogdir is /var/log/jbossas  (any logs must go here)
%define jbosslogdir %{_localstatedir}/log/%{base_name}
# jbstandalonelogdir is /var/log/jbossas/standalone  (any mutable file like logs must go here)
%define jbstandalonelogdir %{jbosslogdir}/standalone


%{?scl:%scl_package %{?scl_prefix}jboss-ec2-eap}
%{!?scl:%global pkg_name wildfly}
%global confdir %{_sysconfdir}/%{pkg_name}

Summary:       EAP 7 AS Standalone Configuration for EC2
Name:          %{?scl_prefix}jboss-ec2-eap
Version:       %{jbossas_version}
Release:       1%{fullreltag}%{?dist}
Epoch:         0
License:       LGPL
Group:         Development/Installer
URL:           http://www.jboss.org/

#git clone git://git.app.eng.bos.redhat.com/mw-cloud.git
#git archive 9fdc4b58c79223b8dd13ec1cd74a3033cacb2e88 --format=tgz --prefix=mw-cloud/ > mw-cloud-%{namedversion}.tar.gz
#For RHEL6, git archive 9fdc4b58c79223b8dd13ec1cd74a3033cacb2e88 --prefix=mw-cloud/ | gzip > mw-cloud-%{namedversion}.tar.gz
Source0:       mw-cloud-%{namedversion}.tar.gz
#aws script
Source1:       https://raw.github.com/timkay/aws/master/aws

## -------------- generate standalone.xml ----------------
#Package URL: https://brewweb.devel.redhat.com/packageinfo?packageID=55702
#git clone -n git://git.app.eng.bos.redhat.com/wildfly.git
#git reset --hard 38461fc421b3e3a5b7b6d9d9ba9920b23f77acf0
########################
#http://git.app.eng.bos.redhat.com/git/mw-cloud.git/tree/phase3/eap7/ami/README?h=7.0.x
#Current files:
#* configuration/standalone/subsystems-ec2-ha.xml copy to JBOSSAS_SRC_DIR/feature-pack/src/main/resources/configuration/standalone/subsystems-ha.xml
#* configuration/domain/subsystems-ec2.xml copy to JBOSSAS_SRC_DIR/feature-pack/src/main/resources/configuration/domain/subsystems.xml
#* configuration/domain/template-ec2.xml copy to JBOSSAS_SRC_DIR/feature-pack/src/main/resources/configuration/domain/template.xml
#* configuration/subsystems/jgroups-ec2.xml to JBOSSAS_SRC_DIR/clustering/jgroups/extension/src/main/resources/subsystem-templates/
#* configuration/subsystems/mod_cluster-ec2.xml to JBOSSAS_SRC_DIR/mod_cluster/extension/src/main/resources/subsystem-templates/
#* configuration/subsystems/undertow-ec2.xml to JBOSSAS_SRC_DIR/undertow/src/main/resources/subsystem-templates/
#* CLEAN-UP.txt cleanup everything from the list before generating an AMI from the running instance
#Future files:
#* package-yum.txt - commands used to install EAP (for now, see https://docspace.corp.redhat.com/docs/DOC-99526)
#* package-list.txt - package list of our prototype image
########################
#cp mw-cloud/phase3/eap7/ami/configuration/standalone/subsystems-ec2-ha.xml wildfly/feature-pack/src/main/resources/configuration/standalone/subsystems-ha.xml
#cp mw-cloud/phase3/eap7/ami/configuration/domain/subsystems-ec2.xml wildfly/feature-pack/src/main/resources/configuration/domain/subsystems.xml
#cp mw-cloud/phase3/eap7/ami/configuration/domain/template-ec2.xml wildfly/feature-pack/src/main/resources/configuration/domain/template.xml
#cp mw-cloud/phase3/eap7/ami/configuration/subsystems/jgroups-ec2.xml wildfly/clustering/jgroups/extension/src/main/resources/subsystem-templates/
#cp mw-cloud/phase3/eap7/ami/configuration/subsystems/mod_cluster-ec2.xml wildfly/mod_cluster/extension/src/main/resources/subsystem-templates/
#cp mw-cloud/phase3/eap7/ami/configuration/subsystems/undertow-ec2.xml wildfly/undertow/src/main/resources/subsystem-templates/
#cd wildfly
###wget http://repo1.maven.org/maven2/org/jboss/maven/extension/dependency/maven-dependency-management-extension/1.1.0/maven-dependency-management-extension-1.1.0.jar -P tools/maven/lib/ext
# build all modules
# may need to do some change to pom.xml, for example: comment checkstyle plugin, core-module-tests, subsystem-test, tests artifacts in jgroups&infinispan  modules
# mvn -s /local/apache-maven-3.2.3/conf/settings-7.0-mead.xml -DskipTests=true -Prelease  -Denforcer.skip=true -Dmaven.repo.local=/local/localRepo -Dversion.suffix=redhat-1 clean install
#cp build/target/jboss-eap-7.0/standalone/configuration/standalone-ha.xml ../../standalone-mod_cluster-ec2-ha.xml
#cp build/target/jboss-eap-7.0/domain/configuration/domain.xml ../../domain-ec2.xml
Source5: standalone-mod_cluster-ec2-ha.xml
Source6: domain-ec2.xml
#comment mod_cluster-ec2 subsystem in feature-pack/src/main/resources/configuration/standalone/subsystems-ha.xml, rebuild
#cp build/target/jboss-eap-7.0/standalone/configuration/standalone-ha.xml ../../standalone-ec2-ha.xml
#cd ..
Source2: standalone-ec2-ha.xml

#svn export -r 2516 http://anonsvn.jboss.org/repos/qa/people/akostadi/hellojsp
#tar czf hellojsp.tar.gz hellojsp/
Source3:        hellojsp.tar.gz

#git clone git://github.com/liweinan/cluster-demo.git
#git archive 38a84036275db25f8192c48ab0f3605a63d08958 --prefix=cluster-demo/ | gzip > cluster-demo.tar.gz
Source4:        cluster-demo.tar.gz

Source33:       hello.war
Source44:       cluster-demo.war


#wget https://jenkins.hosts.mwqe.eng.bos.redhat.com/hudson/job/jboss-eap-7.0.x-quickstarts/lastSuccessfulBuild/artifact/jboss-eap-7.0.5.CP.CR2-quickstarts.zip
#wget http://download.devel.redhat.com/devel/candidates/JBEAP/JBEAP-7.0.5.CP.CR2/jboss-eap-7.0.5.CP.CR2-full-maven-repository.zip
#unzip jboss-eap-7.0.5.CP.CR2-quickstarts.zip
#unzip jboss-eap-7.0.5.CP.CR2-full-maven-repository.zip
#cd jboss-eap-7.0.5.GA-quickstarts/helloworld-mdb
#sed "s#https://maven.repository[^<]*#file:///local/DistGIT/jboss-ec2-eap/temp/jboss-eap-7.0.5.GA-maven-repository#gi" pom.xml -i
#/local/apache-maven-3.2.3/bin/mvn clean package -s /local/apache-maven-3.2.3/conf/settings-7.0-mead.xml  -Dmaven.repo.local=/local/localRepo
#(you'll see jboss-as-helloworld-mdb.war in jboss-eap-6.3.0.Beta2-quickstarts/helloworld-mdb/target)
# cp target/jboss-helloworld-mdb.war ../../../jboss-as-helloworld-mdb-%{namedversion}.war
Source7:       jboss-as-helloworld-mdb-%{namedversion}.war

BuildRequires:    %{?scl_prefix}wildfly >= %{as_rpm_version}
#BuildRequires:    jpackage-utils >= 0:1.7.3
#BuildRequires:    jboss-parent
Requires:         %{?scl_prefix}wildfly >= %{as_rpm_version}
#Requires:         jpackage-utils
##########################################################################
###### IMPORTANT:
###### As for CPs, we don't ship the full release, hence the version of
###### jbossas-standalone and jbossas-domain maybe be at the current
###### level or at 6.2.0 level, hence we cannot have the version tied
###### Requires, this needs to be checked when we build this package
##########################################################################
###### Hard coding these Requires: at 7.3.0 (6.2.0 level)
%{?scl:Requires: %scl_runtime}
#Requires:         dos2unix
#Requires:	      util-linux-ng

BuildRoot:    %{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:    noarch

%description
This package contains EAP 7 AS Standalone Configuration for EC2.

%package samples
Summary:        Sample applications fro ec2 eap
Group:          Development/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description samples
%{summary}

%prep
%setup -q -n mw-cloud

%if 0
tar zxf %{SOURCE3}
tar zxf %{SOURCE4}
%endif

%build

%if 0
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL

# hellojsp
pushd hellojsp
mvn-jpp \
        -e \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        install
popd

# cluster-demo
pushd cluster-demo
mvn-jpp \
        -e \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        install
popd
%endif

%install
rm -rf $RPM_BUILD_ROOT

# Config files go there
install -d -m 755 $RPM_BUILD_ROOT%{confdir}/standalone
install -d -m 755 $RPM_BUILD_ROOT%{confdir}/domain
# ec2 config
install -p -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{confdir}/standalone
install -p -m 644 %{SOURCE5} $RPM_BUILD_ROOT%{confdir}/standalone
install -p -m 644 %{SOURCE6} $RPM_BUILD_ROOT%{confdir}/domain

#init script
#install -d -m 755 $RPM_BUILD_ROOT%{_initrddir}
#install -p -m 755 phase2/eap6/ami/ec2-init $RPM_BUILD_ROOT%{_initrddir}/%{name}

# install scripts
#install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/scripts
#install -p -m 755 phase2/eap6/ami/jboss_user-data.sh $RPM_BUILD_ROOT%{_datadir}/%{name}/scripts
#install -p -m 755 phase2/eap6/ami/reserve_peer_id.sh $RPM_BUILD_ROOT%{_datadir}/%{name}/scripts
#install -p -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/%{name}/scripts

#install -d -m 755 $RPM_BUILD_ROOT%{_var}/log
#touch $RPM_BUILD_ROOT%{_var}/log/jboss_user-data.out
#install -d -m 700 $RPM_BUILD_ROOT%{_var}/cache/%{name}
#touch $RPM_BUILD_ROOT%{_var}/cache/%{name}/user-data
#touch $RPM_BUILD_ROOT%{_var}/cache/%{name}/user-data.sh

#samples
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}-samples
#hellojsp
install -m 644 %{SOURCE33} $RPM_BUILD_ROOT%{_javadir}/%{name}-samples/hello.war
#cluster-demo
install -m 644 %{SOURCE44} $RPM_BUILD_ROOT%{_javadir}/%{name}-samples/cluster-demo.war

#jboss-as-helloworld-mdb
install -m 644 %{SOURCE7} $RPM_BUILD_ROOT%{_javadir}/%{name}-samples/

%clean
rm -Rf $RPM_BUILD_ROOT

%if 0
%pre
JBOSS_SHELL=/sbin/nologin
%{_sbindir}/groupadd -r jboss 2>/dev/null || :
%{_sbindir}/useradd -c JBossAS -r -s $JBOSS_SHELL -d %{_localstatedir}/lib/jbossas -g jboss jboss 2>/dev/null || :
if [ "$1" = 2 ]; then
  # stop server before upgrade
  %{_initrddir}/jbossas stop >/dev/null 2>&1 || :
fi

%post
# add jbossas service
[ -x /sbin/chkconfig ] && /sbin/chkconfig --add jbossas || :
%endif

%files
%defattr(0755,root,root,0755)
%if 0
%{_initrddir}/%{name}
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/scripts
%{_datadir}/%{name}/scripts/jboss_user-data.sh
%{_datadir}/%{name}/scripts/reserve_peer_id.sh
%{_datadir}/%{name}/scripts/aws
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/%{base_name}/standalone/standalone-ec2-ha.xml
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/%{base_name}/standalone/standalone-mod_cluster-ec2-ha.xml
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/%{base_name}/domain/domain-ec2.xml
%endif

%attr(0664,root,root) %config(noreplace) %{confdir}/standalone/*.xml
%attr(0664,root,root) %config(noreplace) %{confdir}/domain/*.xml

%if 0
%ghost %{_var}/log/jboss_user-data.out
%endif

%if 0
%defattr(0700,root,root,0700)
%dir %{_var}/cache/%{name}
%ghost %{_var}/cache/%{name}/user-data
%ghost %{_var}/cache/%{name}/user-data.sh
%endif

%files samples
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-samples/*

%changelog
* Fri Mar 03 2017 Yong Yang <yyang@redhat.com> 0:7.0.5-1.GA_redhat_1
- EAP7.0.5.GA-redhat-1

* Wed Dec 21 2016 Yong Yang <yyang@redhat.com> 0:7.0.4-5.GA_redhat_2
- EAP7.0.4.GA-redhat-2

* Tue Nov 29 2016 Yong Yang <yyang@redhat.com> 0:7.0.4-4.GA_redhat_1
- EAP7.0.4.GA-redhat-1

* Wed Oct 19 2016 Yong Yang <yyang@redhat.com> 0:7.0.3-3.GA_redhat_2
- EAP7.0.3.GA-redhat-2

* Mon Aug 29 2016 Yong Yang <yyang@redhat.com> 0:7.0.2-1.GA_redhat_1
- EAP7.0.2.GA-redhat-1

* Thu Jul 07 2016 Yong Yang <yyang@redhat.com> 0:7.0.1-2.GA_redhat_2
- EAP7.0.1.GA-redhat-2

* Tue May 31 2016 Yong Yang <yyang@redhat.com> 0:7.0.0-1.GA_redhat_1
- EAP7.0.1.GA-redhat-1

* Thu Apr 21 2016 Yong Yang <yyang@redhat.com> 0:7.0.0-2.GA_redhat_2
- EAP7.0.0.GA-redhat-2(CR2)

* Wed Apr 20 2016 Yong Yang <yyang@redhat.com> 0:7.0.0-2.CR1_redhat_1
- Rebuild EAP7.0.0.CR1

* Fri Apr 15 2016 Yong Yang <yyang@redhat.com> 0:7.0.0-1.CR1_redhat_1
- EAP7.0.0.CR1

* Wed Mar 23 2016 Yong Yang <yyang@redhat.com> 0:7.0.0-1.ER7_redhat_1
- EAP7.0.0.ER7

* Fri Feb 26 2016 Yong Yang <yyang@redhat.com> 0:7.0.0-1.ER6_redhat_1
- EAP7.0.0.ER6

* Fri Feb 05 2016 Yong Yang <yyang@redhat.com> 0:7.0.0-1.ER5_redhat_1
- EAP7.0.0.ER5

* Mon Jan 18 2016 Yong Yang <yyang@redhat.com> 0:7.0.0-1.ER4_redhat_1
- EAP7.0.0.ER4

* Tue Dec 08 2015 Yong Yang <yyang@redhat.com> 0:0.10.0.0-5.CR6_redhat_1
- Add more scl prefix

* Mon Dec 07 2015 Yong Yang <yyang@redhat.com> 0:0.10.0.0-4.CR6_redhat_1
- Remove jpackage-utils, dos2unix
- Add scl requires

* Thu Dec 03 2015 Yong Yang <yyang@redhat.com> 0:0.10.0.0-3.CR6_redhat_1
- Bump release number

* Thu Dec 03 2015 Yong Yang <yyang@redhat.com> 0:0.10.0.0-2.CR6_redhat_1
- Bump release number

* Tue Dec 01 2015 Yong Yang <yyang@redhat.com> 0:0.10.0.0-1.CR6_redhat_1
- Build for Wildfly 10.0.0.CR6
